/*******************************************************************************
 * Copyright (c) 2024, Skeyes (on behalf of FABEC) and Nilacandi
 * All rights reserved.
 *
 * This source code is licensed under the license found in the
 * LICENSE.txt file in the root directory of this source tree.
 *******************************************************************************/
/**
 * NOTE: This class is auto generated by the swagger code generator program (3.0.36).
 * https://github.com/swagger-api/swagger-codegen Do not edit the class manually.
 */
package aero.facilis.validator.api;

import java.io.IOException;
import java.net.URISyntaxException;
import java.util.List;
import java.util.concurrent.CompletableFuture;
import javax.validation.Valid;
import org.springframework.core.io.Resource;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.multipart.MultipartFile;
import aero.facilis.validator.exception.UserException;
import aero.facilis.validator.model.AixmDoc;
import aero.facilis.validator.model.AixmValidateBody;
import aero.facilis.validator.model.AixmValidateResponse;
import aero.facilis.validator.model.CombinedReport;
import aero.facilis.validator.model.ReportMetadata;
import io.swagger.annotations.Api;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.enums.ParameterIn;
import io.swagger.v3.oas.annotations.media.Content;
import io.swagger.v3.oas.annotations.media.Schema;
import io.swagger.v3.oas.annotations.responses.ApiResponse;
import io.swagger.v3.oas.annotations.responses.ApiResponses;
import io.swagger.v3.oas.annotations.security.SecurityRequirement;

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.SpringCodegen",
    date = "2022-12-16T07:05:00.434Z[GMT]")
@Validated
@Api(tags = "AIXM")
public interface AixmApi {

  @Operation(summary = "Upload an AIXM Document",
      description = "Upload of an AIXM document for validation.",
      security = {@SecurityRequirement(name = "BearerAuth")}, tags = {})
  @ApiResponses(value = {
      @ApiResponse(responseCode = "201", description = "AIXM document uploaded successfully.",
          content = @Content(mediaType = "application/json",
              schema = @Schema(implementation = AixmDoc.class))),
      @ApiResponse(responseCode = "422", description = "AIXM document is corrupted."),
      @ApiResponse(responseCode = "406", description = "AIXM document is rejected."),
      @ApiResponse(responseCode = "500",
          description = "An error occured while processing the request. Please contact the system administrator.")})
  @RequestMapping(value = "/aixm/upload", produces = {"application/json"},
      consumes = MediaType.MULTIPART_FORM_DATA_VALUE, method = RequestMethod.POST)
  ResponseEntity<AixmDoc> uploadAIXMDocument(@Parameter(in = ParameterIn.DEFAULT, description = "",
      schema = @Schema()) @Valid @RequestBody MultipartFile file) throws UserException;


  @Operation(summary = "Validate an AIXM Document",
      description = "Validate an AIXM document based on a schema, extensions and business rules.",
      security = {@SecurityRequirement(name = "BearerAuth")}, tags = {})
  @ApiResponses(value = {
      @ApiResponse(responseCode = "202", description = "The AIXM document has been received.",
          content = @Content(mediaType = "application/json",
              schema = @Schema(implementation = AixmValidateResponse.class)))})
  @RequestMapping(value = "/aixm/validate", produces = {"application/json"},
      consumes = {"application/json"}, method = RequestMethod.POST)
  CompletableFuture<ResponseEntity<AixmValidateResponse>> validate(@Parameter(
      in = ParameterIn.DEFAULT,
      description = "Json representation of user selected schema, extensions and business rules.",
      required = true, schema = @Schema()) @Valid @RequestBody AixmValidateBody body)
      throws UserException, URISyntaxException, aero.facilis.xmlvalidator.exception.UserException;

  @Operation(summary = "Get Validation History", description = "Returns validation history.",
      security = {@SecurityRequirement(name = "BearerAuth")}, tags = {})
  @ApiResponses(value = {@ApiResponse(responseCode = "200", description = "Validation history.",
      content = @Content(mediaType = "application/json",
          schema = @Schema(implementation = ReportMetadata.class)))})
  @RequestMapping(value = "/aixm/validation-history", produces = {"application/json"},
      method = RequestMethod.GET)
  ResponseEntity<List<ReportMetadata>> getValidationHistory() throws UserException;

  @Operation(summary = "Get Validation Report", description = "Returns a validation report.",
      security = {@SecurityRequirement(name = "BearerAuth")}, tags = {})
  @ApiResponses(value = {@ApiResponse(responseCode = "200", description = "A validation report.",
      content = @Content(mediaType = "application/json",
          schema = @Schema(implementation = CombinedReport.class)))})
  @RequestMapping(value = "/aixm/validation-report/{reportFileName}",
      produces = {"application/json"}, method = RequestMethod.GET)
  ResponseEntity<CombinedReport> getValidationReport(
      @Parameter(in = ParameterIn.PATH, description = "", required = true,
          schema = @Schema()) @PathVariable("reportFileName") String reportFileName)
      throws IOException, UserException;

  @Operation(summary = "Get Certificate", description = "Returns a certificate.",
      security = {@SecurityRequirement(name = "BearerAuth")}, tags = {})
  @ApiResponses(value = {
      @ApiResponse(responseCode = "200", description = "OK",
          content = @Content(mediaType = "application/pdf",
              schema = @Schema(implementation = Resource.class))),
      @ApiResponse(responseCode = "404", description = "Certificate not found"),
      @ApiResponse(responseCode = "500",
          description = "An error occured while processing the request. Please contact example@facilis.com.")})
  @RequestMapping(value = "/aixm/certificate/{certificateFileName}", produces = {"application/pdf"},
      method = RequestMethod.GET)
  ResponseEntity<Resource> getCertificate(
      @Parameter(in = ParameterIn.PATH, description = "", required = true,
          schema = @Schema()) @PathVariable("certificateFileName") String certificateFileName)
      throws IOException, UserException;

}

